if (SERVER) then
  
	AddCSLuaFile ("shared.lua")
	SWEP.Weight 			= 5
	SWEP.AutoSwitchTo 		= false
	SWEP.AutoSwitchFrom 		= false
end

if (CLIENT) then

	SWEP.PrintName 			= "Fast Zombie"
	SWEP.Slot 				= 3
	SWEP.SlotPos 			= 1
	SWEP.DrawAmmo 			= true
	SWEP.DrawCrosshair 		= false
	SWEP.ViewModelFOV			= 65
	SWEP.ViewModelFlip		= true
	SWEP.CSMuzzleFlashes		= false
	SWEP.Category			= "Baddog's Pokeballs"

	SWEP.IconLetter 			= "O"
	killicon.AddFont("weapon_real_cs_grenade", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ))
end

SWEP.Primary.NumNades 			= 1 --number of throwable grenades at your disposal

SWEP.Author 				= "Baddog"
SWEP.Contact 				= ""
SWEP.Purpose 				= ""
SWEP.Instructions 			= ""
SWEP.Category				= "Baddog's Pokeballs"

SWEP.Spawnable 				= true
SWEP.AdminSpawnable 			= true

SWEP.ViewModel 				= "models/weapons/v_pokeball.mdl"
SWEP.WorldModel 				= "models/weapons/w_pokeball.mdl"

SWEP.Primary.ClipSize 			= -1
SWEP.Primary.DefaultClip 		= 1
SWEP.Primary.Automatic 			= true
SWEP.Primary.Ammo 			= "grenade"

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 		= -1
SWEP.Secondary.Automatic 		= true
SWEP.Secondary.Ammo 			= "none"

/*---------------------------------------------------------
Initialize
---------------------------------------------------------*/
function SWEP:Initialize()
	if (SERVER) then
		self:SetWeaponHoldType("grenade")
	end
end

/*---------------------------------------------------------
Holster
---------------------------------------------------------*/
function SWEP:Holster()
	self.Proned = false
	self.Throwing = false
	self.Farthrow = 0
	self.Farthrow2 = false

return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
	if self.Proned and not self.Owner:KeyDown ( IN_ATTACK) and self.Owner:KeyReleased(IN_ATTACK) then
		self.Proned = false
		self.Throwing = true
		self.Weapon:SendWeaponAnim(ACT_VM_THROW)

		if self.Farthrow <= CurTime() then self.Farthrow2 = true else self.Farthrow2 = false end
		timer.Simple( 0.35, function()
			self:ThrowFar()
		end )
	end

	if self.Proned and not self.Owner:KeyDown ( IN_ATTACK2) and self.Owner:KeyReleased(IN_ATTACK2) then
		self.Proned = false
		self.Throwing = true
		self.Weapon:SendWeaponAnim(ACT_VM_THROW)

		if self.Farthrow <= CurTime() then self.Farthrow2 = true else self.Farthrow2 = false end
		timer.Simple( 0.4, function()
			self:ThrowShort()
		end )
	end
end

/*---------------------------------------------------------
ThrowFar
---------------------------------------------------------*/
function SWEP:ThrowFar()
	if !self.Throwing then return end
	self.Owner:SetAnimation( PLAYER_ATTACK1 )
	ownerofhegrenade = self.Owner

	local tr = self.Owner:GetEyeTrace()

	if (!SERVER) then return end

	local ent = ents.Create ("pb_fastzombie")

			local v = self.Owner:GetShootPos()
				v = v + self.Owner:GetForward() * 1
				v = v + self.Owner:GetRight() * 3
				v = v + self.Owner:GetUp() * 1
			ent:SetPos( v )

	ent:SetAngles (Vector(math.random(1,100),math.random(1,100),math.random(1,100)))
	ent.GrenadeOwner = self.Owner
	ent:Spawn()
	local phys = ent:GetPhysicsObject()
	local shot_length = tr.HitPos:Length()

	if self.Owner:KeyDown( IN_FORWARD ) then
		self.Force = 3200
	elseif self.Owner:KeyDown( IN_BACK ) then
		self.Force = 2100
	elseif self.Owner:KeyDown( IN_MOVELEFT ) then
		self.Force = 2500
	elseif self.Owner:KeyDown( IN_MOVERIGHT ) then
		self.Force = 2500
	else
		self.Force = 2500
	end

	if self.Farthrow2 then self.Force = self.Force + 600 end

	phys:ApplyForceCenter(self.Owner:GetAimVector() *self.Force *1.2 + Vector(0,0,200) )
	phys:AddAngleVelocity(Vector(math.random(-500,500),math.random(-500,500),math.random(-500,500)))
	self.Primary.NumNades = self.Primary.NumNades - 1
	self.Weapon:SetNextPrimaryFire( CurTime() + 1.6 )

	timer.Simple(0.6,
	function()

	if self.Owner:GetAmmoCount(self.Primary.Ammo) == 1 then
		local owna = self.Owner
		self.Owner:RemoveAmmo(1,self.Primary.Ammo)
		owna:ConCommand("lastinv")

		elseif self.Primary.NumNades <= 0 then
			self.Owner:RemoveAmmo(1,self.Primary.Ammo)
			self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
			self.Proned = false
			self.Throwing = false
			self.Farthrow = 0
			self.Farthrow2 = false
		else
			self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
			self.Proned = false
			self.Throwing = false
			self.Farthrow = 0
			self.Farthrow2 = false
		end
	end)
end

/*---------------------------------------------------------
ThrowShort
---------------------------------------------------------*/
function SWEP:ThrowShort()
	if !self.Throwing then return end
	self.Owner:SetAnimation( PLAYER_ATTACK1 )

	local tr = self.Owner:GetEyeTrace()

	if (!SERVER) then return end

	local ent = ents.Create ("pb_fastzombie")

			local v = self.Owner:GetShootPos()
				v = v + self.Owner:GetForward() * 2
				v = v + self.Owner:GetRight() * 3
				v = v + self.Owner:GetUp() * -3
			ent:SetPos( v )

	ent:SetAngles (Vector(math.random(1,100),math.random(1,100),math.random(1,100)))
	ent:Spawn()
	local phys = ent:GetPhysicsObject()
	local shot_length = tr.HitPos:Length()

	if self.Owner:KeyDown( IN_FORWARD ) then
		self.Force = 1100
	elseif self.Owner:KeyDown( IN_BACK ) then
		self.Force = 300
	elseif self.Owner:KeyDown( IN_MOVELEFT ) then
		self.Force = 700
	elseif self.Owner:KeyDown( IN_MOVERIGHT ) then
		self.Force = 700
	else
		self.Force = 700
	end

	if self.Farthrow2 then self.Force = self.Force + 600 end

	phys:ApplyForceCenter(self.Owner:GetAimVector() * self.Force * 2 + Vector(0, 0, 0))
	phys:AddAngleVelocity(Vector(math.random(-500,500),math.random(-500,500),math.random(-500,500)))
	self.Primary.NumNades = self.Primary.NumNades - 1
	self.Weapon:SetNextPrimaryFire( CurTime() + 1.6 )

	timer.Simple(0.6,
	function()

	if self.Owner:GetAmmoCount(self.Primary.Ammo) == 1 then
		local owna = self.Owner
		self.Owner:RemoveAmmo(1,self.Primary.Ammo)
		owna:ConCommand("lastinv")

		elseif self.Primary.NumNades <= 0 then
			self.Owner:RemoveAmmo(1,self.Primary.Ammo)
			self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
			self.Proned = false
			self.Throwing = false
			self.Farthrow = 0
			self.Farthrow2 = false
		else
			self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
			self.Proned = false
			self.Throwing = false
			self.Farthrow = 0
			self.Farthrow2 = false
		end
	end)
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
	if self.Throwing then return end

	if !self.Proned then
		self.Weapon:SendWeaponAnim(ACT_VM_PULLPIN)
		self.Proned = true
		self.Farthrow = 2 + CurTime()
	end
end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
	self:PrimaryAttack()
end

/*---------------------------------------------------------
Deploy
---------------------------------------------------------*/
function SWEP:Deploy()
	self.Weapon:SetNextPrimaryFire(CurTime()+1)
	self.Weapon:SetNextSecondaryFire(CurTime()+1)
	self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
	return true
end

/*---------------------------------------------------------
DrawWeaponSelection
---------------------------------------------------------*/
function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)
	draw.SimpleText(self.IconLetter, "CSSelectIcons", x + wide/2, y + tall*0.2, Color(255, 210, 0, 255), TEXT_ALIGN_CENTER)

	-- try to fool them into thinking they're playing a Tony Hawks game
	draw.SimpleText(self.IconLetter, "CSSelectIcons", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-14, 14), Color(255, 210, 0, math.Rand(10, 120)), TEXT_ALIGN_CENTER)
	draw.SimpleText(self.IconLetter, "CSSelectIcons", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-9, 9), Color(255, 210, 0, math.Rand(10, 120)), TEXT_ALIGN_CENTER)
end